#pragma once

#include <Base_Packet.h>

namespace inaf::oasbo::Packets {

class AstriMaGeneric : public inaf::oasbo::PacketLib::BasePacket {

public:
	AstriMaGeneric(inaf::oasbo::PacketLib::BasePacketStructure &structure) : BasePacket(structure){}
	AstriMaGeneric(inaf::oasbo::PacketLib::BasePacket &other) : BasePacket(other){}
	uint getHeaderSize() const override;
	uint getPayloadSize() const override;
	uint getTailSize() const override;
	bool isRecognizedHeader() const override;
	bool isRecognizedHeader(std::vector<uint8_t> buff) const override;

	uint getTelescopeID() const;
	uint getType() const;
	uint getSubType() const;
	uint getSSC() const;
	uint getPacketLength() const;
	uint getYear() const;
	uint getMonth() const;
	uint getDay() const;
	uint getHour() const;
	uint getMinutes() const;
	uint getSeconds() const;
	bool getValidTime() const;
	uint getTimeTagNanoseconds() const;
	uint getEventCounter() const;
	bool getLid() const;
	bool fibSt() const;
	bool fibCont() const;
	bool fibPuls() const;
	uint rgbCont() const;
	uint rgbPuls() const;



};
}
